Target version: CoCoALib-0.99800 Spent time: 0.70 hour

Description

In issue #1529 we have decided to require that when reading from an istream the stream must be in decimal mode.

Should we require the same for writing to an ostream?

If so, maybe we should supply a function which converts an integer (or rational?) to a string using the given base?

Related issues:

Related to CoCoALib - Design #1529: INPUT questions Closed 31 Oct 2020

History

#1 - 05 Dec 2020 13:55 - John Abbott

- Related to Design #1529: INPUT questions added

#2 - 17 Feb 2021 10:09 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

I do not like the idea of converting a BigInt or BigRat to a non-decimal string via normal output operators.

[We could produce an explicit fn which does convert BigInt or BigRat to a string using a given base]

I suggest using assertions to check that ostream is in decimal mode; or possibly print out a warning?

It could be surprising to the user/programmer if printing can cause an error.

#3 - 17 Feb 2021 10:27 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 10 to 70

I have now added assertions to printing for BigInt, BigRat (which anyway prints a BigInt), PPMonoidElem, and finite fields.

That should cover virtually all cases!

PS: and symbol

#4 - 17 Feb 2021 11:06 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 70 to 90

I have changed most/all output fns so that they assert that the ostream is in decimal mode.

Contrast with input fns which give error is istream is not in decimal mode.
https://cocoa.dima.unige.it/redmine/issues/1529


It is possible that some minor output fns have been skipped... probably not so important.

#5 - 04 Feb 2022 21:50 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 0.70 h
